;	org $1001-2
;	dw  $1001
;	
;	dw nextln,0	; second word is line number
;	db $9e
;	if start > 9999
;	db "0"+start/10000
;	endif
;	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
;nextln	db 0,0

data_src = $B0
code_dst = $B2

DEST1 = $D200
DEST2 = $E000

set_clr	macro idx
	sty DEST2+6+idx*7
	;
	dex
	bne *+2+7
	lda next,y
	tay
	db $BF			;lax sizes,y
	dw sizes
	endm

square_init	
	;
	; *** unpack lines
	;
	lda $FF07
	and #$40
	beq sq_pal
	;
	lda #$D8		; NTSC changes: reduce number of lines
	sta lines1+1
	lda #$01		; move up entire effect
	sta sq_loop+1
	lda #$4C		; place JMP so4 at line $D0 (skip rest)
	sta sq_D8
	lda #so4 & 255
	sta sq_D8+1
	lda #so4 >> 8
	sta sq_D8+2
	;
sq_pal	lda #letter_data & 255
	sta data_src
	lda #letter_data >> 8
	sta data_src+1
	;
	ldy #$00
	ldx #DEST1 >> 8
	;
init2	sty code_dst		; create the "line" routines
	stx code_dst+1		; each routine draws one line of the letters
	;
	ldx #22			; length of each letter
init1	jsr get_byte		; get "command byte" from table
	jsr put_byte
	lda #$19		; +$FF19
	jsr put_byte
	lda #$FF
	jsr put_byte
	dex
	bpl init1
	;
	lda #$60		; RTS opcode at the end
	jsr put_byte
	;             
	ldx code_dst+1
	inx
	cpx #(DEST1 >> 8)+$0E
	bne init2
	;
	; *** generate "page" code
	;
	ldy #$00
	sty code_dst
	lda #DEST2 >> 8
	sta code_dst+1
	;
	ldx #$00
	;
init3	lda #$A9		; lda #$xx
	jsr put_byte
	lda colors,x
	jsr put_byte
	;
	lda #$24		; 3 cycle padding
	jsr put_byte
	jsr put_byte 
	;
	lda #$20		; JSR call to a line
	jsr put_byte 
	lda #$00
	jsr put_byte
	lda #(DEST1 >> 8)+$D	; initial call: line $D (empty line)
	jsr put_byte
	;
	inx
lines1	cpx #$00
	bne init3
	;
	txa
	bne init5
	;
init4	lda #$A9		; lda #$xx
	jsr put_byte
	lda colors+$100,x
	jsr put_byte
	;
	lda #$24		; 3 cycle padding
	jsr put_byte
	jsr put_byte 
	;
	lda #$20		; JSR call to a line
	jsr put_byte 
	lda #$00
	jsr put_byte
	lda #(DEST1 >> 8)+$D	; initial call: line $D (empty line)
	jsr put_byte
	;
	inx
	cpx #$0A		; total size: $10A lines
	bne init4
	;
init5	lda #$60
	jmp put_byte
	
get_byte
	lda (data_src),y
	inc data_src
	bne *+4
	inc data_src+1
	rts
	
put_byte
	sta (code_dst),y
	inc code_dst
	bne *+4
	inc code_dst+1
	rts
	
	;
	; ====================
	;

square_start
	lda #$0B		; screen off
	sta $FF06
	;
	; ====================
	;
	lda #$F8
	cmp $FF1D
	bne *-3
	;
sq_loop	lda #$1A
	cmp $FF1D
	bne *-3
	;
r4_snr4_c0
	lda $FF1E
	cmp #$D0
	bcc r4_snr4_c0		; FF1E will be in $D0-$E0 range
	;
	cmp #$E0		; 2
	beq r4_snc9		; 2 ; 3 if taken = 5  + 8 ahead = 13
	cmp #$DE		; 2
	beq r4_snc8		; 2 ; 3 if taken = 9  + 7 ahead = 16
	cmp #$DC		; 2
	beq r4_snc7		; 2 ; 3 if taken = 13 + 6 ahead = 19
	cmp #$DA		; 2
	beq r4_snc6		; 2 ; 3 if taken = 17 + 5 ahead = 22
	cmp #$D8		; 2
	beq r4_snc5		; 2 ; 3 if taken = 21 + 4 ahead = 25
	cmp #$D6		; 2
	beq r4_snc4		; 2 ; 3 if taken = 25 + 3 ahead = 28 / needs 9
	cmp #$D4		; 2
	beq r4_snc3		; 2 ; 3 if taken = 29 + 2 ahead = 31 / needs 6
	cmp #$D2		; 2
	beq r4_snc2		; 2 ; 3 if taken = 33 + 1 ahead = 34 / needs 3
	cmp #$D0		; 2
	beq r4_snr4_c1		; 2 ; 3 if taken = 37
r4_snc9	bit $24
r4_snc8	bit $24
r4_snc7	bit $24
r4_snc6	bit $24
r4_snc5	bit $24
r4_snc4	bit $24
r4_snc3	bit $24
r4_snc2	bit $24	; 3
r4_snr4_c1
	;
	bit $24
	bit $24
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	nop
	nop
	;
	ldy #$FF
	ldx #$00
	;
	; ---
	;
	jsr DEST2
	;
	; ---
	;
	jsr PLAYER
	;
	;dec $FF19		; debug
	;
start_offset
	ldy #DEST1 >> 8
	ldx #$01
	;
	set_clr $00
	set_clr $01
	set_clr $02
	set_clr $03
	set_clr $04
	set_clr $05
	set_clr $06
	set_clr $07
	set_clr $08
	set_clr $09
	set_clr $0A
	set_clr $0B
	set_clr $0C
	set_clr $0D
	set_clr $0E
	set_clr $0F
	set_clr $10
	set_clr $11
	set_clr $12
	set_clr $13
	set_clr $14
	set_clr $15
	set_clr $16
	set_clr $17
	set_clr $18
	set_clr $19
	set_clr $1A
	set_clr $1B
	set_clr $1C
	set_clr $1D
	set_clr $1E
	set_clr $1F
	set_clr $20
	set_clr $21
	set_clr $22
	set_clr $23
	set_clr $24
	set_clr $25
	set_clr $26
	set_clr $27
	set_clr $28
	set_clr $29
	set_clr $2A
	set_clr $2B
	set_clr $2C
	set_clr $2D
	set_clr $2E
	set_clr $2F
	set_clr $30
	set_clr $31
	set_clr $32
	set_clr $33
	set_clr $34
	set_clr $35
	set_clr $36
	set_clr $37
	set_clr $38
	set_clr $39
	set_clr $3A
	set_clr $3B
	set_clr $3C
	set_clr $3D
	set_clr $3E
	set_clr $3F
	set_clr $40
	set_clr $41
	set_clr $42
	set_clr $43
	set_clr $44
	set_clr $45
	set_clr $46
	set_clr $47
	set_clr $48
	set_clr $49
	set_clr $4A
	set_clr $4B
	set_clr $4C
	set_clr $4D
	set_clr $4E
	set_clr $4F
	set_clr $50
	set_clr $51
	set_clr $52
	set_clr $53
	set_clr $54
	set_clr $55
	set_clr $56
	set_clr $57
	set_clr $58
	set_clr $59
	set_clr $5A
	set_clr $5B
	set_clr $5C
	set_clr $5D
	set_clr $5E
	set_clr $5F
	set_clr $60
	set_clr $61
	set_clr $62
	set_clr $63
	set_clr $64
	set_clr $65
	set_clr $66
	set_clr $67
	set_clr $68
	set_clr $69
	set_clr $6A
	set_clr $6B
	set_clr $6C
	set_clr $6D
	set_clr $6E
	set_clr $6F
	set_clr $70
	set_clr $71
	set_clr $72
	set_clr $73
	set_clr $74
	set_clr $75
	set_clr $76
	set_clr $77
	set_clr $78
	set_clr $79
	set_clr $7A
	set_clr $7B
	set_clr $7C
	set_clr $7D
	set_clr $7E
	set_clr $7F
	set_clr $80
	set_clr $81
	set_clr $82
	set_clr $83
	set_clr $84
	set_clr $85
	set_clr $86
	set_clr $87
	set_clr $88
	set_clr $89
	set_clr $8A
	set_clr $8B
	set_clr $8C
	set_clr $8D
	set_clr $8E
	set_clr $8F
	set_clr $90
	set_clr $91
	set_clr $92
	set_clr $93
	set_clr $94
	set_clr $95
	set_clr $96
	set_clr $97
	set_clr $98
	set_clr $99
	set_clr $9A
	set_clr $9B
	set_clr $9C
	set_clr $9D
	set_clr $9E
	set_clr $9F
	set_clr $A0
	set_clr $A1
	set_clr $A2
	set_clr $A3
	set_clr $A4
	set_clr $A5
	set_clr $A6
	set_clr $A7
	set_clr $A8
	set_clr $A9
	set_clr $AA
	set_clr $AB
	set_clr $AC
	set_clr $AD
	set_clr $AE
	set_clr $AF
	set_clr $B0
	set_clr $B1
	set_clr $B2
	set_clr $B3
	set_clr $B4
	set_clr $B5
	set_clr $B6
	set_clr $B7
	set_clr $B8
	set_clr $B9
	set_clr $BA
	set_clr $BB
	set_clr $BC
	set_clr $BD
	set_clr $BE
	set_clr $BF
	set_clr $C0
	set_clr $C1
	set_clr $C2
	set_clr $C3
	set_clr $C4
	set_clr $C5
	set_clr $C6
	set_clr $C7
	set_clr $C8
	set_clr $C9
	set_clr $CA
	set_clr $CB
	set_clr $CC
	set_clr $CD
	set_clr $CE
	set_clr $CF
	set_clr $D0
	set_clr $D1
	set_clr $D2
	set_clr $D3
	set_clr $D4
	set_clr $D5
	set_clr $D6
	set_clr $D7
sq_D8
	set_clr $D8
	set_clr $D9
	set_clr $DA
	set_clr $DB
	set_clr $DC
	set_clr $DD
	set_clr $DE
	set_clr $DF
	set_clr $E0
	set_clr $E1
	set_clr $E2
	set_clr $E3
	set_clr $E4
	set_clr $E5
	set_clr $E6
	set_clr $E7
	set_clr $E8
	set_clr $E9
	set_clr $EA
	set_clr $EB
	set_clr $EC
	set_clr $ED
	set_clr $EE
	set_clr $EF
	set_clr $F0
	set_clr $F1
	set_clr $F2
	set_clr $F3
	set_clr $F4
	set_clr $F5
	set_clr $F6
	set_clr $F7
	set_clr $F8
	set_clr $F9
	set_clr $FA
	set_clr $FB
	set_clr $FC
	set_clr $FD
	set_clr $FE
	set_clr $FF
	set_clr $100
	set_clr $101
	set_clr $102
	set_clr $103
	set_clr $104
	set_clr $105
	set_clr $106
	set_clr $107
	set_clr $108
	set_clr $109
;	set_clr $10A
;	set_clr $10B
;	set_clr $10C
;	set_clr $10D
;	set_clr $10E
;	set_clr $10F
	;
	; ---
	;
so4	ldx #$44		; initial delay
	beq so3
	dex
	stx so4+1
	jmp so5
	;
so3	ldx #(DEST1 >> 8)+$1
	inc sizes,x		; increase size (grow)
	txa
	clc
	adc #$02		; only every second "size" (leave single lines alone)
	cmp #(DEST1 >> 8)+$D	; wrap
	bne *+4
	lda #(DEST1 >> 8)+$1
	sta so3+1
	;
so5	; -----------------------------------
	;
	lda start_offset+3
	sec
	sbc #$01
	bne so2
	;
	lda start_offset+1
	clc
	adc #$01
	cmp #(DEST1 >> 8)+$E
	bne so1
	lda #(DEST1 >> 8)
so1	sta start_offset+1
	tax
	lda sizes,x
	;
so2	sta start_offset+3
	;
so6	ldx #$F0		; total time (in frames)
	beq so7
	dex
	stx so6+1
	jmp sq_loop
	;
so7	lda #$1B
	sta $FF06
	rts
	
	align 256
sizes	ds (DEST1>>8)
	db 1,2,1,2, 1,2,1,2
	db 1,2,1,2, 1,2,1,2
	db 1,2,1,2, 1,2,1,2
	
	align 256
next
	ds (DEST1>>8)
	db (DEST1>>8)+$1,(DEST1>>8)+$2,(DEST1>>8)+$3,(DEST1>>8)+$4,(DEST1>>8)+$5,(DEST1>>8)+$6,(DEST1>>8)+$7,(DEST1>>8)+$8
	db (DEST1>>8)+$9,(DEST1>>8)+$A,(DEST1>>8)+$B,(DEST1>>8)+$C,(DEST1>>8)+$D,(DEST1>>8)+$0
	
xC = $8D
xH = $8C
xB = $8E
xS = $2C
	
letter_data
	db xH,xS,xS,xB, xH,xS,xS,xB, xH,xB,xH,xB, xH,xS,xS,xB, xH,xS,xS,xB, xH,xS,xB	; 0
	db xC,xS,xS,xB, xC,xS,xS,xB, xC,xB,xC,xB, xC,xS,xS,xB, xC,xS,xS,xB, xC,xS,xB	; 1
	db xC,xH,xS,xB, xC,xH,xC,xB, xC,xB,xC,xB, xC,xH,xC,xB, xC,xH,xS,xB, xC,xH,xB	; 2
	db xC,xB,xS,xS, xC,xB,xC,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xB,xS,xS, xC,xB,xS	; 3
	db xC,xH,xS,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xH,xC,xB, xC,xB,xS,xS, xC,xH,xB	; 4
	db xC,xS,xS,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xS,xS,xB, xC,xB,xS,xS, xC,xS,xB	; 5
	db xH,xS,xC,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xH,xC,xB, xC,xB,xS,xS, xC,xH,xB	; 6
	db xS,xS,xC,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xB,xC,xB, xC,xB,xS,xS, xC,xB,xS	; 7
	db xH,xS,xC,xB, xC,xH,xC,xB, xC,xH,xC,xB, xC,xB,xC,xB, xC,xB,xS,xS, xC,xH,xB	; 8
	db xC,xS,xS,xB, xC,xS,xS,xB, xC,xS,xS,xB, xC,xB,xC,xB, xC,xB,xS,xS, xC,xS,xB	; 9
	db xH,xS,xS,xB, xH,xC,xH,xB, xH,xS,xS,xB, xH,xB,xH,xB, xH,xB,xS,xS, xH,xS,xB	; A
	db xS,xS,xS,xS, xS,xC,xS,xB, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS	; B
	db xS,xS,xS,xS, xS,xH,xS,xB, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS	; C
	db xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS,xS, xS,xS,xS	; D
	
	align 256
	; 2 b 4 e 6 d 3 c 5 f a 7 9 8 2
colors
	db $02,$22,$42,$52,$62,$72,$72,$62,$52,$42,$22,$02
	db $02,$2B,$42,$5B,$62,$7B,$72,$62,$5B,$42,$2B,$02
	db $0B,$2B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$2B,$0B
	db $0B,$24,$4B,$54,$6B,$74,$7B,$64,$5B,$44,$2B,$04
	db $04,$24,$44,$54,$64,$74,$74,$64,$54,$44,$24,$04
	db $04,$2E,$44,$5E,$64,$7E,$74,$6E,$54,$4E,$24,$0E
	db $0E,$2E,$4E,$5E,$6E,$7E,$7E,$6E,$5E,$4E,$2E,$0E
	db $0E,$26,$4E,$56,$6E,$76,$7E,$66,$5E,$46,$2E,$06
	db $06,$26,$46,$56,$66,$76,$76,$66,$56,$46,$26,$06
	db $06,$2D,$46,$5D,$66,$7D,$76,$6D,$56,$4D,$26,$0D
	db $0D,$2D,$4D,$5D,$6D,$7D,$7D,$6D,$5D,$4D,$2D,$0D
	db $0D,$23,$4D,$53,$6D,$73,$7D,$63,$5D,$43,$2D,$03
	db $03,$23,$43,$53,$63,$73,$73,$63,$53,$43,$23,$03
	db $03,$2C,$43,$5C,$63,$7C,$73,$6C,$53,$4C,$23,$0C
	db $0C,$2C,$4C,$5C,$6C,$7C,$7C,$6C,$5C,$4C,$2C,$0C
	db $0C,$25,$4C,$55,$6C,$75,$7C,$65,$5C,$45,$2C,$05
	db $05,$25,$45,$55,$65,$75,$75,$65,$55,$45,$25,$05
	db $05,$2F,$45,$5F,$65,$7F,$75,$6F,$55,$4F,$25,$0F
	db $0F,$2F,$4F,$5F,$6F,$7F,$7F,$6F,$5F,$4F,$2F,$0F
	db $0F,$2A,$4F,$5A,$6F,$7A,$7F,$6A,$5F,$4A,$2F,$0A
	db $0A,$2A,$4A,$5A,$6A,$7A,$7A,$6A,$5A,$4A,$2A,$0A
	db $0A,$27,$4A,$57,$6A,$77,$7A,$67,$5A,$47,$2A,$07
	db $07,$27,$47,$57,$67,$77,$77,$67,$57,$47,$27,$07
;eof